﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using C1.WPF.C1Chart;

namespace WPF_Chart_ConditionalAxisLabelFormatting
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            #region Generate Data Source for DataSeries
            DateTime dt = new DateTime(2012, 12, 01);
            ObservableCollection<string> xValueList = new ObservableCollection<string>();
            for (int i = 0; i < 20; i++)
            {
                string tempDate = dt.AddDays(i).ToString("MM/dd");
                xValueList.Add(tempDate);
            }

            ObservableCollection<double?> valueList = new ObservableCollection<double?>();
            valueList.Add(2030);
            valueList.Add(5242);
            valueList.Add(null);
            valueList.Add(2130);
            valueList.Add(1323);

            valueList.Add(9239);
            valueList.Add(2030);
            valueList.Add(8902);
            valueList.Add(3032);
            valueList.Add(null);

            valueList.Add(6033);
            valueList.Add(7323);
            valueList.Add(3920);
            valueList.Add(2390);
            valueList.Add(2030);

            valueList.Add(2393);
            valueList.Add(2030);
            valueList.Add(1900);
            valueList.Add(7320);
            valueList.Add(null);

            #endregion

            # region DataSeries
            DataSeries ds = new DataSeries();
            ds.ChartType = ChartType.Column;

            ds.ValuesSource = valueList;
            c1Chart1.Data.Children.Add(ds);
            #endregion

            #region Axis X Settings

            c1Chart1.View.AxisX.IsTime = true;
            c1Chart1.View.AxisX.AnnoFormat = "MM/dd";
            c1Chart1.View.AxisX.AnnoAngle = -60;

            c1Chart1.Data.ItemNames = xValueList.ToArray();
            
            #endregion
        }

        private void Axis_AnnoCreated(object sender, AnnoCreatedEventArgs e)
        {
            if (((c1Chart1.Data.Children[0] as DataSeries).ValuesSource as ObservableCollection<double?>)[e.Index] == null)
                (e.Label as TextBlock).Foreground = new SolidColorBrush(Colors.Red);
        }
    }
  
}
